<template>
  <div
    class="flex items-center"
    v-for="(option, index) in options"
    :key="index"
  >
    <input
      type="checkbox"
      :id="option.value"
      :value="option.value"
      v-model="localSelectedCheckbox"
      :disabled="option.disabled"
      :checked="option.selected"
    />
    <label :for="option.value" class="label" :disabled="option.disabled">{{
      option.label
    }}</label>
  </div>
</template>

<script setup lang="ts">
import { reactive, watch, ref, toRef } from "vue";

const props = defineProps<{
  options: Array<{
    label: string;
    value: string;
    selected?: boolean;
    disabled?: boolean;
  }>;
}>();
const localSelectedCheckbox: Ref<Array<string>> = ref([]);
watch(props.options, () => {
  const disabledOptions = [];
  const localOptions = props.options;
  localOptions.forEach((datum) => {
    if (datum.disabled) {
      disabledOptions.push(datum.value);
    }
  });
  disabledOptions.forEach((datum) => {
    const selectedIndex = localSelectedCheckbox.value.findIndex(
      (value) => value === datum
    );
    if (selectedIndex !== -1) {
      localSelectedCheckbox.value.splice(selectedIndex, 1);
    }
  });
});
const emit = defineEmits(["setSelectedValue"]);
watch(localSelectedCheckbox, () => {
  emit("setSelectedValue", localSelectedCheckbox);
});
</script>

<style lang="scss" scoped>
.label {
  @apply pl-2;
}
label[disabled="true"] {
  @apply opacity-40;
}
</style>